
; /////////////////////////////////////////////////////////////////////////
;
;
;                        Standard Lisp Macros
;                        by Arthur Flood
;
;                        email address:   artflood@aol.com
; 
;
; /////////////////////////////////////////////////////////////////////////




; (vmon)

(defun c:c  () (command "copy"))
(defun c:cw () (command "copy" "w"))
(defun c:cc () (command "copy" "c"))
(defun c:m  () (command "move"))
(defun c:mw () (command "move" "w"))
(defun c:mc () (command "move" "c"))
(defun c:e  () (command "erase"))
(defun c:ew () (command "erase" "w"))
(defun c:ec () (command "erase" "c"))
(defun c:r  () (command "rotate"))
(defun c:rw () (command "rotate" "w"))
(defun c:rc () (command "rotate" "c"))
(defun c:mi () (command "mirror"))
(defun c:ls () (command "list"))

(defun c:l  () (command "line") )
(defun c:li () (command "line" "int"))
(defun c:le () (command "line" "end"))
(defun c:lm () (command "line" "mid"))
(defun c:lc () (command "line" "cen"))
(defun c:lq () (command "line" "quad"))
(defun c:lt () (command "line" "tan"))
(defun c:lp () (command "line" "perp"))

(defun c:lee () (command "line" "end" pause "end" pause))
(defun c:lii () (command "line" "int" pause "int" pause))
(defun c:lei () (command "line" "end" pause "int" pause))
(defun c:lie () (command "line" "int" pause "end" pause))
(defun c:lcc () (command "line" "cen" pause "cen" pause))

(defun c:ex () (command "explode"))
(defun c:x  () (command "extend"))
(defun c:xx () (command "extend"))
(defun c:o  () (command "offset"))

(defun c:n  () (command "pan"))
(defun c:t  () (command "trim"))

(defun c:f  () (command "fillet"))
(defun c:f0 () (command "fillet" "r" "0" "fillet"))
(defun c:ch () (command "chamfer"))
(defun c:wb () (command "wblock"))
(defun c:bl () (command "block"))
(defun c:i  () (command "insert"))
(defun c:ci () (command "circle"))
(defun c:el () (command "ellipse"))
(defun c:b  () (command "break"))
(defun c:bb () (command "break" "f"))

(defun c:ar () (command "array"))
(defun c:cg () (command "change"))
(defun c:st () (command "stretch" "c"))
(defun c:sc () (command "scale"))
(defun c:tx () (command "text"))
(defun c:dt () (command "dtext"))

(defun c:pl () (command "pline"))
(defun c:ee () (command "end"))
(defun c:s  () (command "save"))
(defun c:pwd () (c:dwg))
(defun c:tcac () (c:actc))

(defun c:qq () (command "quit" "y"))
(defun c:zw () (command "zoom" "w"))
(defun c:w  () (command "zoom" "w"))
(defun c:ze () (command "zoom" "e"))
(defun c:za () (command "zoom" "a"))
(defun c:aa () (command "zoom" "a"))
(defun c:zp () (command "zoom" "p"))
(defun c:p  () (command "zoom" "p"))
(defun c:rr () (command "redraw"))
(defun c:rrr () (command "regen"))

(defun c:oo () (command "zoom" "0.75x"))
(defun c:ooo () (command "zoom" "0.5x"))
(defun c:oooo () (command "zoom" "0.3x"))
(defun c:iiii () (command "zoom" "2x"))
(defun c:iii () (command "zoom" "1.5x"))
(defun c:ii () (command "zoom" "1.33x"))

(defun c:vp () (command "vports"))
(defun c:uu () (command "ucs"))
(defun c:ddd () (command "ddatte"))

(defun c:back () (c:rear))
(defun c:front () (command "plan" ""))
(defun c:ux () (command "ucs" "x"))
(defun c:uy () (command "ucs" "y"))
(defun c:uz () (command "ucs" "z"))
(defun c:uv () (command "ucs" "v"))

(defun c:os () (command "osnap"))
(defun c:oi () (command "osnap" "int,end"))
(defun c:oe () (command "osnap" "end,int"))
(defun c:oc () (command "osnap" "cen"))
(defun c:om () (command "osnap" "mid"))
(defun c:off () (command "osnap" "off"))
(defun c:of () (command "osnap" "off"))

(defun c:dl () (command "dim1" "leader"))
(defun c:dln () (command "dim1" "leader" "near"))

(defun c:ss1 () (setq ss1 (ssget)))
(defun c:ss2 () (setq ss2 (ssget)))

(defun c:ps () (command "pspace"))
(defun c:ms () (command "mspace"))

(defun c:d ()
(command "osnap" "int,end")
(command "dist")
(command "osnap" "off")
)

(defun c:lll ()
(setq s (getstring "Load  Lisp  File :  "))
(SETQ SS S)
(load ss)
)


(defun c:dwg (/ a b)
(setq a (getvar "dwgprefix") b (getvar "dwgname"))
(prompt "\nWorking Drawing:  ")(princ a)(princ b)
(prompt ".DWG\n \n")
(princ)
)


(defun c:top ()
(command "ucs" "x" "-90" "plan" "" "ucs" "p")
)

(defun c:bottom ()
(command "ucs" "x" "90" "plan" "" "ucs" "p")
)

(defun c:right ()
(command "ucs" "y" "90" "plan" "" "ucs" "p")
)

(defun c:left ()
(command "ucs" "y" "-90" "plan" "" "ucs" "p")
)

(defun c:rear ()
(command "ucs" "y" "180" "plan" "" "ucs" "p")
)

(defun c:cv ()
(if (not c:cutview)  (load "cutview"))
(c:cutview)
)


(defun c:gn ()
(if (not c:getnotes)  (load "getnotes"))
(c:getnotes)
)


(princ "AutoLisp...")(princ)